package tests;



import static org.junit.Assert.fail;

import org.junit.Assert;
import org.junit.Test;

import simplification.Binary;
import simplification.Entier;
import simplification.Operator;
import simplification.Variable;

public class BinaryTest {
	Variable x=new Variable("x");
	Variable z= new Variable("z");
	Variable y=new Variable("y");
	
	Entier trois=new Entier(3);
	Entier deux=new Entier(2);
	Entier cinq=new Entier(5);
	Entier six=new Entier(6);
	
	// x*x
	Binary b1=new Binary(x,Operator.MULT,x);
	// 1-x
	Binary ex=new Binary(Entier.UN,Operator.MOINS,x);
	//1+x
	Binary b2=new Binary(Entier.UN,Operator.PLUS,x);
	// b1+b2
	Binary b3= new Binary(b1,Operator.PLUS,b2);
	Binary b4=new Binary(ex,Operator.MULT,b3);
	// x+z
	Binary exp1=new Binary(x,Operator.PLUS,z);
	Binary e=new Binary(x,Operator.MOINS,z);
	Binary f=new Binary(e,Operator.MULT,exp1);
	Binary exp2=new Binary(z,Operator.MOINS,x);
	Binary exp3=new Binary(exp2,Operator.MULT,exp1);
	// 3+6
	Binary exp4=new Binary(trois,Operator.PLUS,six);
	Binary exp5=new Binary(exp4,Operator.MULT,exp3);
	// 1+2
	Binary exp=new Binary(Entier.UN,Operator.PLUS,deux);
	// exp4+exp
	Binary exp7=new Binary(exp4,Operator.MULT,exp);
	Binary duo=new Binary(ex,Operator.MULT,exp);
	Binary trio=new Binary(cinq,Operator.MOINS,y);
	Binary t= new Binary(duo,Operator.MULT,trio);
	Binary a=new Binary(x,Operator.PLUS,Entier.ZERO);
	Binary b= new Binary(z,Operator.MOINS,Entier.ZERO);
	Binary c =new Binary(a,Operator.PLUS,b);
	Binary fi=new Binary(exp2,Operator.MULT,duo);

	@Test
	public void testBinary() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetLeft() {
		Assert.assertTrue(a.getLeft() == x);
	}

	@Test
	public void testGetRight() {
		Assert.assertTrue(a.getRight().isZero());
	}

	@Test
	public void testGetOp() {
		Assert.assertFalse(a.getOp().getName().equals("-"));
		Assert.assertTrue(a.getOp().getName().equals("+"));
	}

	@Test
	public void testToString() {
		Assert.assertEquals("(x + 0)", a.toString());
	}

	@Test
	public void testIsComputable() {
		Assert.assertFalse(a.isComputable());
		Assert.assertTrue(exp4.isComputable());
	}

	@Test
	// exemple interessant passage du niveau methode
	// au niveau instructions est instructifs
	public void testCompute() {
		Assert.assertTrue(exp4.compute() == 9);
		Assert.assertTrue(exp7.compute() == 27);
		Assert.assertTrue(new Binary(exp4,Operator.MOINS,exp).compute() == 6);
		Assert.assertTrue(new Binary(exp4,Operator.DIV,exp).compute() == 3);
	}

	@Test
	public void testIsZero() {
		Assert.assertFalse(exp4.isZero());
	}

	@Test
	public void testIsUnit() {
		Assert.assertFalse(exp4.isUnit());
	}

	@Test
	public void testOneReduction() {
		Assert.assertEquals("9", exp4.oneReduction().toString());
		Assert.assertEquals("27", exp7.oneReduction().toString());
	}

	@Test
	public void testEngine() {
		fail("Not yet implemented");
	}

}
