package tests;

import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import simplification.Entier;

public class EntierTest {
		Entier trois;

	@Before
	public void set() {
		trois = new Entier(3);
	}
	
	@Test
	public void testGetValeur() {
		Assert.assertTrue(trois.getValue() == 3);
		Assert.assertTrue(Entier.ZERO.getValue() == 0);
		Assert.assertTrue(Entier.UN.getValue() == 1);
	}

	@Test
	public void testEntier() {
		//Assert.assertTrue(new Entier(3).equals(trois));
		Assert.assertTrue(trois.getValue() == 3);
	}


	@Test
	public void testIsZero() {
		Assert.assertTrue(Entier.ZERO.isZero());
		Assert.assertFalse(Entier.UN.isZero());
	}

	@Test
	public void testIsUnit() {
		Assert.assertFalse(Entier.ZERO.isUnit());
		Assert.assertTrue(Entier.UN.isUnit());
	}
	
	@Test
	public void testToString() {
		Assert.assertEquals(trois.toString(), "3");
	}

	@Test
	public void testIsComputable() {
		Assert.assertTrue(trois.isComputable());
	}

	@Test
	public void testCompute() {
		assertTrue(trois.getValue() == trois.compute());
	}

	@Test
	public void testOneReduction() {
		assertTrue(trois.oneReduction() == trois);
	}

	@Test
	public void testEngine() {
		assertTrue(Entier.ZERO.engine() == Entier.ZERO);
		assertTrue(trois.engine() == trois);
	}

	@After
	public void unset() {
		trois = null;
	}
}
